#ifndef __KTAP_STACKTRACE_H__
#define __KTAP_STACKTRACE_H__

#include <linux/stacktrace.h>

#if LINUX_VERSION_CODE >= KERNEL_VERSION(5, 2, 0)
typedef struct {
	unsigned int nr_entries, max_entries;
	unsigned long *entries;
	int skip;
} kp_stack_trace_t;

static void kp_save_stack_trace(kp_stack_trace_t *trace)
{
	trace->nr_entries = stack_trace_save(trace->entries,
					     trace->max_entries, trace->skip);
}

#else // 5.2.0

typedef struct stack_trace kp_stack_trace_t;

static void kp_save_stack_trace(kp_stack_trace_t *trace)
{
	save_stack_trace((struct stack_trace*) trace);
}

#endif // 5.2.0

#endif /* __KTAP_STACKTRACE_H__ */
